#include "lis3mdl.h"
//--------------------------------------------
//   
volatile int16_t xbuf_avg[8]={0},ybuf_avg[8]={0},zbuf_avg[8]={0};
//    
volatile int8_t avg_cnt;
//   
volatile int64_t tmp64[3];
//--------------------------------------------
extern I2C_HandleTypeDef hi2c1;
extern UART_HandleTypeDef huart2;
uint8_t buf2[14]={0};
char str1[30]={0};
//--------------------------------------------
void Error(void)
{
	LD2_OFF;
}
//--------------------------------------------
void MovingAverage(int16_t* dt)
{
	if(avg_cnt<8)
	{
		xbuf_avg[avg_cnt]=dt[0];
		ybuf_avg[avg_cnt]=dt[1];
		zbuf_avg[avg_cnt]=dt[2];
		if(avg_cnt==7)
		{
			tmp64[0]=xbuf_avg[7]+xbuf_avg[6]+xbuf_avg[5]+xbuf_avg[4]+\
							 xbuf_avg[3]+xbuf_avg[2]+xbuf_avg[1]+xbuf_avg[0];
			tmp64[1]=ybuf_avg[7]+ybuf_avg[6]+ybuf_avg[5]+ybuf_avg[4]+\
							 ybuf_avg[3]+ybuf_avg[2]+ybuf_avg[1]+ybuf_avg[0];
			tmp64[2]=zbuf_avg[7]+zbuf_avg[6]+zbuf_avg[5]+zbuf_avg[4]+\
							 zbuf_avg[3]+zbuf_avg[2]+zbuf_avg[1]+zbuf_avg[0];
			dt[0]=tmp64[0]/8;
			dt[1]=tmp64[1]/8;
			dt[2]=tmp64[2]/8;
		}
		avg_cnt++;
	}
	else
	{
		//     ( ) 
		tmp64[0]-=xbuf_avg[0];
		tmp64[1]-=ybuf_avg[0];
		tmp64[2]-=zbuf_avg[0];
		//   1 
		memcpy((void*)xbuf_avg,(void*)(xbuf_avg+1),sizeof(int16_t)*7);
		memcpy((void*)ybuf_avg,(void*)(ybuf_avg+1),sizeof(int16_t)*7);
		memcpy((void*)zbuf_avg,(void*)(zbuf_avg+1),sizeof(int16_t)*7);
		// 7   
		xbuf_avg[7]=dt[0];
		ybuf_avg[7]=dt[1];
		zbuf_avg[7]=dt[2];
		//  
		tmp64[0]+=dt[0];
		tmp64[1]+=dt[1];
		tmp64[2]+=dt[2];
		//  
		dt[0]=tmp64[0]/8;
		dt[1]=tmp64[1]/8;
		dt[2]=tmp64[2]/8;
	}
}
//--------------------------------------------
static uint8_t I2Cx_ReadData(uint16_t Addr, uint8_t Reg)
{
	HAL_StatusTypeDef status = HAL_OK;
	uint8_t value = 0;
	status = HAL_I2C_Mem_Read(&hi2c1, Addr, Reg, I2C_MEMADD_SIZE_8BIT, &value, 1, 0x10000);
	if(status != HAL_OK) Error();
	return value;
}
//--------------------------------------------
static void I2Cx_WriteData(uint16_t Addr, uint8_t Reg, uint8_t Value)
{
	HAL_StatusTypeDef status = HAL_OK;
	status = HAL_I2C_Mem_Write(&hi2c1, Addr, (uint16_t)Reg, I2C_MEMADD_SIZE_8BIT, &Value, 1, 0x10000);
	if(status != HAL_OK) Error();
}
//--------------------------------------------
uint8_t Mag_IO_Read(uint16_t DeviceAddr, uint8_t RegisterAddr)
{
	return I2Cx_ReadData(DeviceAddr, RegisterAddr);
}
//--------------------------------------------
void Mag_IO_Write(uint16_t DeviceAddr, uint8_t RegisterAddr, uint8_t Value)
{
	I2Cx_WriteData(DeviceAddr, RegisterAddr, Value);
}
//--------------------------------------------
void Mag_GetXYZ(int16_t* pData)
{
	uint8_t buffer[6];
	uint8_t i=0;
	buffer[0]=Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_OUTX_L);
	buffer[1]=Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_OUTX_H);
	buffer[2]=Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_OUTY_L);
	buffer[3]=Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_OUTY_H);
	buffer[4]=Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_OUTZ_L);
	buffer[5]=Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_OUTZ_H);
	for(i=0;i<3;i++)
	{
		pData[i] = ((int16_t)((uint16_t)buffer[2*i+1]<<8)+buffer[2*i]);
	}
}
//--------------------------------------------
uint8_t Mag_ReadID(void)
{
	uint8_t ctrl = 0x00;
	ctrl = Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_WHO_AM_I_REG);
	return ctrl;
}
//--------------------------------------------
void Mag_Read(void)
{
	int16_t buffer[3] = {0};
	static int16_t val[3], tmp16;
	Mag_GetXYZ(buffer);
	val[0]=buffer[0]-278;
	val[1]=buffer[1]+720;
	val[2]=buffer[2]-555;
	tmp16=HAL_GPIO_ReadPin(GPIOC, GPIO_PIN_13);
	//   ,
	//    
	if(tmp16!=0)	MovingAverage(val);
//	sprintf(str1,"X:%06d Y:%06d Z:%06d\r\n", val[0], val[1], val[2]);
//	HAL_UART_Transmit(&huart2, (uint8_t*)str1,strlen(str1),0x1000);
	buf2[0]=0x11;
	buf2[1]=0x55;
	buf2[2]=(uint8_t)(val[0]>>8);
	buf2[3]=(uint8_t)val[0];
	buf2[4]=(uint8_t)(val[1]>>8);
	buf2[5]=(uint8_t)val[1];
	buf2[6]=(uint8_t)(val[2]>>8);
	buf2[7]=(uint8_t)val[2];
	HAL_UART_Transmit(&huart2,buf2,8,0x1000);	
	if(val[0]>500)
	{
		LD2_ON;
	}
	else 
	{
		LD2_OFF;
	}
	//HAL_Delay(20);
}

//--------------------------------------------
void MagInit(uint16_t InitStruct)
{
	uint8_t value = 0;
//   (MD = 0x02)
	value = Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG3);
	value&=~LIS3MDL_MAG_MD_MASK;
	value|=LIS3MDL_MAG_MD_POWER_DOWN;
	Mag_IO_Write(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG3,value);
//Enable BDU
	value = Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG5);
	value&=~LIS3MDL_MAG_BDU_MASK;
	value|=LIS3MDL_MAG_BDU_ENABLE;
	Mag_IO_Write(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG5,value);
// Data Rate 80 
	value = Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG1);
	value&=~LIS3MDL_MAG_DO_MASK;
	value|=LIS3MDL_MAG_DO_80Hz;
	Mag_IO_Write(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG1,value);
//Full scale selection 4 gauss
	value = Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG2);
	value&=~LIS3MDL_MAG_FS_MASK;
	value|=LIS3MDL_MAG_FS_12Ga;
	Mag_IO_Write(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG2,value);
//      X  Y
	value = Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG1);
	value&=~LIS3MDL_MAG_OM_MASK;
	value|=LIS3MDL_MAG_OM_HIGH;
	Mag_IO_Write(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG1,value);
//  
	value = Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG1);
	value&=~LIS3MDL_MAG_TEMP_EN_MASK;
	value|=LIS3MDL_MAG_TEMP_EN_DISABLE;
	Mag_IO_Write(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG1,value);
//   (MD = 0x00)
	value = Mag_IO_Read(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG3);
	value&=~LIS3MDL_MAG_MD_MASK;
	value|=LIS3MDL_MAG_MD_CONTINUOUS;
	Mag_IO_Write(MAG_I2C_ADDRESS,LIS3MDL_MAG_CTRL_REG3,value);
}
//--------------------------------------------
void Mag_Ini(void)
{
	uint16_t ctrl = 0x0000;
	//    
	avg_cnt=0;
	HAL_Delay(1000);
	if(Mag_ReadID()==LIS3MDL_MAG_WHO_AM_I) LD2_ON;
	else Error();
	LD2_OFF;
	MagInit(ctrl);
	LD2_ON;
}
